diff --git a/compiler/basicTypes/MkId.lhs b/compiler/basicTypes/MkId.lhs
index 4a0b7d7..a38345e 100644
--- a/compiler/basicTypes/MkId.lhs
+++ b/compiler/basicTypes/MkId.lhs
@@ -12,12 +12,6 @@ have a standard form, namely:
 - primitive operations
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module MkId (
         mkDictFunId, mkDictFunTy, mkDictSelId,
@@ -37,8 +31,8 @@ module MkId (
         voidArgId, nullAddrId, seqId, lazyId, lazyIdKey,
         coercionTokenId, magicSingIId,
 
-	-- Re-export error Ids
-	module PrelRules
+        -- Re-export error Ids
+        module PrelRules
     ) where
 
 #include "HsVersions.h"
@@ -52,7 +46,7 @@ import FamInstEnv
 import Coercion
 import TcType
 import MkCore
-import CoreUtils	( exprType, mkCast )
+import CoreUtils        ( exprType, mkCast )
 import CoreUnfold
 import Literal
 import TyCon
@@ -125,7 +119,7 @@ is right here.
 wiredInIds :: [Id]
 wiredInIds
   =  [lazyId]
-  ++ errorIds		-- Defined in MkCore
+  ++ errorIds           -- Defined in MkCore
   ++ ghcPrimIds
 
 -- These Ids are exported from GHC.Prim
@@ -271,11 +265,11 @@ recover the original type signature from the class op selector.
 
 \begin{code}
 mkDictSelId :: DynFlags
-            -> Bool	     -- True <=> don't include the unfolding
-			     -- Little point on imports without -O, because the
-			     -- dictionary itself won't be visible
- 	    -> Name	     -- Name of one of the *value* selectors 
-	       		     -- (dictionary superclass or method)
+            -> Bool          -- True <=> don't include the unfolding
+                             -- Little point on imports without -O, because the
+                             -- dictionary itself won't be visible
+            -> Name          -- Name of one of the *value* selectors 
+                             -- (dictionary superclass or method)
             -> Class -> Id
 mkDictSelId dflags no_unf name clas
   = mkGlobalId (ClassOpId clas) name sel_ty info
@@ -291,29 +285,29 @@ mkDictSelId dflags no_unf name clas
                 `setArityInfo`         1
                 `setStrictnessInfo`    strict_sig
                 `setUnfoldingInfo`     (if no_unf then noUnfolding
-	                                else mkImplicitUnfolding dflags rhs)
-		   -- In module where class op is defined, we must add
-		   -- the unfolding, even though it'll never be inlined
-		   -- because we use that to generate a top-level binding
-		   -- for the ClassOp
+                                        else mkImplicitUnfolding dflags rhs)
+                   -- In module where class op is defined, we must add
+                   -- the unfolding, even though it'll never be inlined
+                   -- because we use that to generate a top-level binding
+                   -- for the ClassOp
 
     info | new_tycon = base_info `setInlinePragInfo` alwaysInlinePragma
-    	   	   -- See Note [Single-method classes] in TcInstDcls
-		   -- for why alwaysInlinePragma
+                   -- See Note [Single-method classes] in TcInstDcls
+                   -- for why alwaysInlinePragma
          | otherwise = base_info  `setSpecInfo`       mkSpecInfo [rule]
-		       		  `setInlinePragInfo` neverInlinePragma
-		   -- Add a magic BuiltinRule, and never inline it
-		   -- so that the rule is always available to fire.
-		   -- See Note [ClassOp/DFun selection] in TcInstDcls
+                                  `setInlinePragInfo` neverInlinePragma
+                   -- Add a magic BuiltinRule, and never inline it
+                   -- so that the rule is always available to fire.
+                   -- See Note [ClassOp/DFun selection] in TcInstDcls
 
     n_ty_args = length tyvars
 
     -- This is the built-in rule that goes
-    -- 	    op (dfT d1 d2) --->  opT d1 d2
+    --      op (dfT d1 d2) --->  opT d1 d2
     rule = BuiltinRule { ru_name = fsLit "Class op " `appendFS` 
-    	   	       	 	     occNameFS (getOccName name)
+                                     occNameFS (getOccName name)
                        , ru_fn    = name
-    	               , ru_nargs = n_ty_args + 1
+                       , ru_nargs = n_ty_args + 1
                        , ru_try   = dictSelRule val_index n_ty_args }
 
         -- The strictness signature is of the form U(AAAVAAAA) -> T
@@ -327,27 +321,27 @@ mkDictSelId dflags no_unf name clas
                           mkProdDmd [ if the_arg_id == id then evalDmd else absDmd
                                     | id <- arg_ids ]
 
-    tycon      	   = classTyCon clas
-    new_tycon  	   = isNewTyCon tycon
-    [data_con] 	   = tyConDataCons tycon
-    tyvars     	   = dataConUnivTyVars data_con
-    arg_tys    	   = dataConRepArgTys data_con	-- Includes the dictionary superclasses
+    tycon          = classTyCon clas
+    new_tycon      = isNewTyCon tycon
+    [data_con]     = tyConDataCons tycon
+    tyvars         = dataConUnivTyVars data_con
+    arg_tys        = dataConRepArgTys data_con  -- Includes the dictionary superclasses
 
     -- 'index' is a 0-index into the *value* arguments of the dictionary
     val_index      = assoc "MkId.mkDictSelId" sel_index_prs name
     sel_index_prs  = map idName (classAllSelIds clas) `zip` [0..]
 
     the_arg_id     = getNth arg_ids val_index
-    pred       	   = mkClassPred clas (mkTyVarTys tyvars)
-    dict_id    	   = mkTemplateLocal 1 pred
-    arg_ids    	   = mkTemplateLocalsNum 2 arg_tys
+    pred           = mkClassPred clas (mkTyVarTys tyvars)
+    dict_id        = mkTemplateLocal 1 pred
+    arg_ids        = mkTemplateLocalsNum 2 arg_tys
 
     rhs = mkLams tyvars  (Lam dict_id   rhs_body)
     rhs_body | new_tycon = unwrapNewTypeBody tycon (map mkTyVarTy tyvars) (Var dict_id)
              | otherwise = Case (Var dict_id) dict_id (idType the_arg_id)
                                 [(DataAlt data_con, arg_ids, varToCoreExpr the_arg_id)]
-				-- varToCoreExpr needed for equality superclass selectors
-				--   sel a b d = case x of { MkC _ (g:a~b) _ -> CO g }
+                                -- varToCoreExpr needed for equality superclass selectors
+                                --   sel a b d = case x of { MkC _ (g:a~b) _ -> CO g }
 
 dictSelRule :: Int -> Arity -> RuleFun
 -- Tries to persuade the argument to look like a constructor
@@ -420,7 +414,7 @@ mkDataConWorkId wkr_name data_con
     id_arg1      = mkTemplateLocal 1 (head nt_arg_tys)
     newtype_unf  = ASSERT2( isVanillaDataCon data_con &&
                             isSingleton nt_arg_tys, ppr data_con  )
-			      -- Note [Newtype datacons]
+                              -- Note [Newtype datacons]
                    mkCompulsoryUnfolding $ 
                    mkLams nt_tvs $ Lam id_arg1 $ 
                    wrapNewTypeBody tycon res_ty_args (Var id_arg1)
@@ -485,34 +479,34 @@ mkDataConRep dflags fam_envs wrap_name data_con
 
        ; let wrap_id = mkGlobalId (DataConWrapId data_con) wrap_name wrap_ty wrap_info
              wrap_info = noCafIdInfo
-                    	 `setArityInfo`         wrap_arity
-                    	     -- It's important to specify the arity, so that partial
-                    	     -- applications are treated as values
-		    	 `setInlinePragInfo`    alwaysInlinePragma
-                    	 `setUnfoldingInfo`     wrap_unf
-                    	 `setStrictnessInfo`    wrap_sig
-                    	     -- We need to get the CAF info right here because TidyPgm
-                    	     -- does not tidy the IdInfo of implicit bindings (like the wrapper)
-                    	     -- so it not make sure that the CAF info is sane
-
-    	     wrap_sig = mkStrictSig (mkTopDmdType wrap_arg_dmds (dataConCPR data_con))
-    	     wrap_arg_dmds = map mk_dmd (dropList eq_spec wrap_bangs)
-    	     mk_dmd str | isBanged str = evalDmd
-    	                | otherwise    = topDmd
-    	         -- The Cpr info can be important inside INLINE rhss, where the
-    	         -- wrapper constructor isn't inlined.
-    	         -- And the argument strictness can be important too; we
-    	         -- may not inline a contructor when it is partially applied.
-    	         -- For example:
-    	         --      data W = C !Int !Int !Int
-    	         --      ...(let w = C x in ...(w p q)...)...
-    	         -- we want to see that w is strict in its two arguments
-
-    	     wrap_unf = mkInlineUnfolding (Just wrap_arity) wrap_rhs
+                         `setArityInfo`         wrap_arity
+                             -- It's important to specify the arity, so that partial
+                             -- applications are treated as values
+                         `setInlinePragInfo`    alwaysInlinePragma
+                         `setUnfoldingInfo`     wrap_unf
+                         `setStrictnessInfo`    wrap_sig
+                             -- We need to get the CAF info right here because TidyPgm
+                             -- does not tidy the IdInfo of implicit bindings (like the wrapper)
+                             -- so it not make sure that the CAF info is sane
+
+             wrap_sig = mkStrictSig (mkTopDmdType wrap_arg_dmds (dataConCPR data_con))
+             wrap_arg_dmds = map mk_dmd (dropList eq_spec wrap_bangs)
+             mk_dmd str | isBanged str = evalDmd
+                        | otherwise    = topDmd
+                 -- The Cpr info can be important inside INLINE rhss, where the
+                 -- wrapper constructor isn't inlined.
+                 -- And the argument strictness can be important too; we
+                 -- may not inline a contructor when it is partially applied.
+                 -- For example:
+                 --      data W = C !Int !Int !Int
+                 --      ...(let w = C x in ...(w p q)...)...
+                 -- we want to see that w is strict in its two arguments
+
+             wrap_unf = mkInlineUnfolding (Just wrap_arity) wrap_rhs
              wrap_tvs = (univ_tvs `minusList` map fst eq_spec) ++ ex_tvs
-    	     wrap_rhs = mkLams wrap_tvs $ 
-    	                mkLams wrap_args $
-    	                wrapFamInstBody tycon res_ty_args $
+             wrap_rhs = mkLams wrap_tvs $ 
+                        mkLams wrap_args $
+                        wrapFamInstBody tycon res_ty_args $
                         wrap_body
 
        ; return (DCR { dcr_wrap_id = wrap_id
@@ -532,9 +526,9 @@ mkDataConRep dflags fam_envs wrap_name data_con
 
     wrap_arg_tys = theta ++ orig_arg_tys
     wrap_arity   = length wrap_arg_tys
-    	     -- The wrap_args are the arguments *other than* the eq_spec
-    	     -- Because we are going to apply the eq_spec args manually in the
-    	     -- wrapper
+             -- The wrap_args are the arguments *other than* the eq_spec
+             -- Because we are going to apply the eq_spec args manually in the
+             -- wrapper
 
     (wrap_bangs, rep_tys_w_strs, wrappers)
        = unzip3 (zipWith (dataConArgRep dflags fam_envs) all_arg_tys orig_bangs)
@@ -548,10 +542,10 @@ mkDataConRep dflags fam_envs wrap_name data_con
 
     initial_wrap_app = Var (dataConWorkId data_con)
                       `mkTyApps`  res_ty_args
-    	              `mkVarApps` ex_tvs                 
-    	              `mkCoApps`  map (mkReflCo Nominal . snd) eq_spec
-    	                -- Dont box the eq_spec coercions since they are
-    	                -- marked as HsUnpack by mk_dict_strict_mark
+                      `mkVarApps` ex_tvs                 
+                      `mkCoApps`  map (mkReflCo Nominal . snd) eq_spec
+                        -- Dont box the eq_spec coercions since they are
+                        -- marked as HsUnpack by mk_dict_strict_mark
 
     mk_boxer :: [Boxer] -> DataConBoxer
     mk_boxer boxers = DCB (\ ty_args src_vars -> 
@@ -771,22 +765,22 @@ The representation arguments of MkR are the *representation* arguments
 of S (plus Int); the rep args of MkS are Int#.  This is all fine.
 
 But be careful not to try to unbox this!
-	data T = MkT {-# UNPACK #-} !T Int
+        data T = MkT {-# UNPACK #-} !T Int
 Because then we'd get an infinite number of arguments.
 
 Here is a more complicated case:
-	data S = MkS {-# UNPACK #-} !T Int
-	data T = MkT {-# UNPACK #-} !S Int
+        data S = MkS {-# UNPACK #-} !T Int
+        data T = MkT {-# UNPACK #-} !S Int
 Each of S and T must decide independendently whether to unpack
 and they had better not both say yes. So they must both say no.
 
 Also behave conservatively when there is no UNPACK pragma
-	data T = MkS !T Int
+        data T = MkS !T Int
 with -funbox-strict-fields or -funbox-small-strict-fields
 we need to behave as if there was an UNPACK pragma there.
 
 But it's the *argument* type that matters. This is fine:
-	data S = MkS S !Int
+        data S = MkS S !Int
 because Int is non-recursive.
 
 
@@ -803,7 +797,7 @@ space for each equality predicate, so it's pretty important!
 \begin{code}
 mk_pred_strict_mark :: PredType -> HsBang
 mk_pred_strict_mark pred 
-  | isEqPred pred = HsUnpack Nothing	-- Note [Unpack equality predicates]
+  | isEqPred pred = HsUnpack Nothing    -- Note [Unpack equality predicates]
   | otherwise     = HsNoBang
 \end{code}
 
@@ -1091,7 +1085,7 @@ nullAddrId = pcMiscPrelId nullAddrName addrPrimTy info
                        `setUnfoldingInfo`  mkCompulsoryUnfolding (Lit nullAddrLit)
 
 ------------------------------------------------
-seqId :: Id	-- See Note [seqId magic]
+seqId :: Id     -- See Note [seqId magic]
 seqId = pcMiscPrelId seqName ty info
   where
     info = noCafIdInfo `setInlinePragInfo` alwaysInlinePragma
@@ -1121,7 +1115,7 @@ match_seq_of_cast _ _ _ [Type _, Type res_ty, Cast scrut co, expr]
 match_seq_of_cast _ _ _ _ = Nothing
 
 ------------------------------------------------
-lazyId :: Id	-- See Note [lazyId magic]
+lazyId :: Id    -- See Note [lazyId magic]
 lazyId = pcMiscPrelId lazyIdName ty info
   where
     info = noCafIdInfo
@@ -1149,7 +1143,7 @@ coerceId = pcMiscPrelId coerceName ty info
     [eqR,x,eq] = mkTemplateLocals [eqRTy, alphaTy,eqRPrimTy]
     rhs = mkLams [alphaTyVar,betaTyVar,eqR,x] $
           mkWildCase (Var eqR) eqRTy betaTy $
-	  [(DataAlt coercibleDataCon, [eq], Cast (Var x) (CoVarCo eq))]
+          [(DataAlt coercibleDataCon, [eq], Cast (Var x) (CoVarCo eq))]
 \end{code}
 
 Note [Unsafe coerce magic]
@@ -1307,7 +1301,7 @@ voidArgId :: Id
 voidArgId       -- :: State# RealWorld
   = mkSysLocal (fsLit "void") voidArgIdKey realWorldStatePrimTy
 
-coercionTokenId :: Id 	      -- :: () ~ ()
+coercionTokenId :: Id         -- :: () ~ ()
 coercionTokenId -- Used to replace Coercion terms when we go to STG
   = pcMiscPrelId coercionTokenName 
                  (mkTyConApp eqPrimTyCon [liftedTypeKind, unitTy, unitTy])
diff --git a/compiler/basicTypes/NameEnv.lhs b/compiler/basicTypes/NameEnv.lhs
index 79433ca..3d0d735 100644
--- a/compiler/basicTypes/NameEnv.lhs
+++ b/compiler/basicTypes/NameEnv.lhs
@@ -5,26 +5,20 @@
 \section[NameEnv]{@NameEnv@: name environments}
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module NameEnv (
-	-- * Var, Id and TyVar environments (maps) 
-	NameEnv, 
-	
-	-- ** Manipulating these environments
-	mkNameEnv,
-	emptyNameEnv, unitNameEnv, nameEnvElts, nameEnvUniqueElts,
-	extendNameEnv_C, extendNameEnv_Acc, extendNameEnv,
+        -- * Var, Id and TyVar environments (maps) 
+        NameEnv, 
+        
+        -- ** Manipulating these environments
+        mkNameEnv,
+        emptyNameEnv, unitNameEnv, nameEnvElts, nameEnvUniqueElts,
+        extendNameEnv_C, extendNameEnv_Acc, extendNameEnv,
         extendNameEnvList, extendNameEnvList_C,
-	foldNameEnv, filterNameEnv,
-	plusNameEnv, plusNameEnv_C, alterNameEnv,
-	lookupNameEnv, lookupNameEnv_NF, delFromNameEnv, delListFromNameEnv,
-	elemNameEnv, mapNameEnv,
+        foldNameEnv, filterNameEnv,
+        plusNameEnv, plusNameEnv_C, alterNameEnv,
+        lookupNameEnv, lookupNameEnv_NF, delFromNameEnv, delListFromNameEnv,
+        elemNameEnv, mapNameEnv,
 
         -- ** Dependency analysis
         depAnal
@@ -40,9 +34,9 @@ import Maybes
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Name environment}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -66,50 +60,50 @@ depAnal get_defs get_uses nodes
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Name environment}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-type NameEnv a = UniqFM a	-- Domain is Name
+type NameEnv a = UniqFM a       -- Domain is Name
 
-emptyNameEnv   	   :: NameEnv a
-mkNameEnv	   :: [(Name,a)] -> NameEnv a
-nameEnvElts    	   :: NameEnv a -> [a]
+emptyNameEnv       :: NameEnv a
+mkNameEnv          :: [(Name,a)] -> NameEnv a
+nameEnvElts        :: NameEnv a -> [a]
 nameEnvUniqueElts  :: NameEnv a -> [(Unique, a)]
 alterNameEnv       :: (Maybe a-> Maybe a) -> NameEnv a -> Name -> NameEnv a
 extendNameEnv_C    :: (a->a->a) -> NameEnv a -> Name -> a -> NameEnv a
 extendNameEnv_Acc  :: (a->b->b) -> (a->b) -> NameEnv b -> Name -> a -> NameEnv b
-extendNameEnv  	   :: NameEnv a -> Name -> a -> NameEnv a
-plusNameEnv    	   :: NameEnv a -> NameEnv a -> NameEnv a
-plusNameEnv_C  	   :: (a->a->a) -> NameEnv a -> NameEnv a -> NameEnv a
+extendNameEnv      :: NameEnv a -> Name -> a -> NameEnv a
+plusNameEnv        :: NameEnv a -> NameEnv a -> NameEnv a
+plusNameEnv_C      :: (a->a->a) -> NameEnv a -> NameEnv a -> NameEnv a
 extendNameEnvList  :: NameEnv a -> [(Name,a)] -> NameEnv a
 extendNameEnvList_C :: (a->a->a) -> NameEnv a -> [(Name,a)] -> NameEnv a
-delFromNameEnv 	   :: NameEnv a -> Name -> NameEnv a
+delFromNameEnv     :: NameEnv a -> Name -> NameEnv a
 delListFromNameEnv :: NameEnv a -> [Name] -> NameEnv a
-elemNameEnv    	   :: Name -> NameEnv a -> Bool
-unitNameEnv    	   :: Name -> a -> NameEnv a
-lookupNameEnv  	   :: NameEnv a -> Name -> Maybe a
+elemNameEnv        :: Name -> NameEnv a -> Bool
+unitNameEnv        :: Name -> a -> NameEnv a
+lookupNameEnv      :: NameEnv a -> Name -> Maybe a
 lookupNameEnv_NF   :: NameEnv a -> Name -> a
-foldNameEnv	   :: (a -> b -> b) -> b -> NameEnv a -> b
-filterNameEnv	   :: (elt -> Bool) -> NameEnv elt -> NameEnv elt
-mapNameEnv	   :: (elt1 -> elt2) -> NameEnv elt1 -> NameEnv elt2
+foldNameEnv        :: (a -> b -> b) -> b -> NameEnv a -> b
+filterNameEnv      :: (elt -> Bool) -> NameEnv elt -> NameEnv elt
+mapNameEnv         :: (elt1 -> elt2) -> NameEnv elt1 -> NameEnv elt2
 
 nameEnvElts x         = eltsUFM x
-emptyNameEnv  	      = emptyUFM
+emptyNameEnv          = emptyUFM
 unitNameEnv x y       = unitUFM x y 
 extendNameEnv x y z   = addToUFM x y z
 extendNameEnvList x l = addListToUFM x l
 lookupNameEnv x y     = lookupUFM x y
 alterNameEnv          = alterUFM
 mkNameEnv     l       = listToUFM l
-elemNameEnv x y 	 = elemUFM x y
-foldNameEnv a b c	 = foldUFM a b c 
-plusNameEnv x y		 = plusUFM x y 
-plusNameEnv_C f x y	 = plusUFM_C f x y 
+elemNameEnv x y          = elemUFM x y
+foldNameEnv a b c        = foldUFM a b c 
+plusNameEnv x y          = plusUFM x y 
+plusNameEnv_C f x y      = plusUFM_C f x y 
 extendNameEnv_C f x y z  = addToUFM_C f x y z
-mapNameEnv f x         	 = mapUFM f x
+mapNameEnv f x           = mapUFM f x
 nameEnvUniqueElts x      = ufmToList x
 extendNameEnv_Acc x y z a b  = addToUFM_Acc x y z a b
 extendNameEnvList_C x y z = addListToUFM_C x y z
diff --git a/compiler/basicTypes/NameSet.lhs b/compiler/basicTypes/NameSet.lhs
index f65fe8b..18a5906 100644
--- a/compiler/basicTypes/NameSet.lhs
+++ b/compiler/basicTypes/NameSet.lhs
@@ -4,36 +4,30 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module NameSet (
-	-- * Names set type
-	NameSet,
-	
-	-- ** Manipulating these sets
-	emptyNameSet, unitNameSet, mkNameSet, unionNameSets, unionManyNameSets,
-	minusNameSet, elemNameSet, nameSetToList, addOneToNameSet, addListToNameSet, 
-	delFromNameSet, delListFromNameSet, isEmptyNameSet, foldNameSet, filterNameSet,
-	intersectsNameSet, intersectNameSet,
-	
-	-- * Free variables
-	FreeVars,
-	
-	-- ** Manipulating sets of free variables
-	isEmptyFVs, emptyFVs, plusFVs, plusFV, 
-	mkFVs, addOneFV, unitFV, delFV, delFVs,
-
-	-- * Defs and uses
-	Defs, Uses, DefUse, DefUses,
-	
-	-- ** Manipulating defs and uses
-	emptyDUs, usesOnly, mkDUs, plusDU, 
-	findUses, duDefs, duUses, allUses
+        -- * Names set type
+        NameSet,
+        
+        -- ** Manipulating these sets
+        emptyNameSet, unitNameSet, mkNameSet, unionNameSets, unionManyNameSets,
+        minusNameSet, elemNameSet, nameSetToList, addOneToNameSet, addListToNameSet, 
+        delFromNameSet, delListFromNameSet, isEmptyNameSet, foldNameSet, filterNameSet,
+        intersectsNameSet, intersectNameSet,
+        
+        -- * Free variables
+        FreeVars,
+        
+        -- ** Manipulating sets of free variables
+        isEmptyFVs, emptyFVs, plusFVs, plusFV, 
+        mkFVs, addOneFV, unitFV, delFV, delFVs,
+
+        -- * Defs and uses
+        Defs, Uses, DefUse, DefUses,
+        
+        -- ** Manipulating defs and uses
+        emptyDUs, usesOnly, mkDUs, plusDU, 
+        findUses, duDefs, duUses, allUses
     ) where
 
 #include "HsVersions.h"
@@ -44,48 +38,48 @@ import UniqSet
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[Sets of names}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 type NameSet = UniqSet Name
 
 emptyNameSet       :: NameSet
-unitNameSet	   :: Name -> NameSet
+unitNameSet        :: Name -> NameSet
 addListToNameSet   :: NameSet -> [Name] -> NameSet
 addOneToNameSet    :: NameSet -> Name -> NameSet
 mkNameSet          :: [Name] -> NameSet
-unionNameSets	   :: NameSet -> NameSet -> NameSet
+unionNameSets      :: NameSet -> NameSet -> NameSet
 unionManyNameSets  :: [NameSet] -> NameSet
-minusNameSet 	   :: NameSet -> NameSet -> NameSet
-elemNameSet	   :: Name -> NameSet -> Bool
-nameSetToList	   :: NameSet -> [Name]
-isEmptyNameSet	   :: NameSet -> Bool
-delFromNameSet	   :: NameSet -> Name -> NameSet
+minusNameSet       :: NameSet -> NameSet -> NameSet
+elemNameSet        :: Name -> NameSet -> Bool
+nameSetToList      :: NameSet -> [Name]
+isEmptyNameSet     :: NameSet -> Bool
+delFromNameSet     :: NameSet -> Name -> NameSet
 delListFromNameSet :: NameSet -> [Name] -> NameSet
-foldNameSet	   :: (Name -> b -> b) -> b -> NameSet -> b
-filterNameSet	   :: (Name -> Bool) -> NameSet -> NameSet
+foldNameSet        :: (Name -> b -> b) -> b -> NameSet -> b
+filterNameSet      :: (Name -> Bool) -> NameSet -> NameSet
 intersectNameSet   :: NameSet -> NameSet -> NameSet
 intersectsNameSet  :: NameSet -> NameSet -> Bool
 -- ^ True if there is a non-empty intersection.
 -- @s1 `intersectsNameSet` s2@ doesn't compute @s2@ if @s1@ is empty
 
 isEmptyNameSet    = isEmptyUniqSet
-emptyNameSet	  = emptyUniqSet
-unitNameSet	  = unitUniqSet
+emptyNameSet      = emptyUniqSet
+unitNameSet       = unitUniqSet
 mkNameSet         = mkUniqSet
 addListToNameSet  = addListToUniqSet
-addOneToNameSet	  = addOneToUniqSet
+addOneToNameSet   = addOneToUniqSet
 unionNameSets     = unionUniqSets
 unionManyNameSets = unionManyUniqSets
-minusNameSet	  = minusUniqSet
+minusNameSet      = minusUniqSet
 elemNameSet       = elementOfUniqSet
 nameSetToList     = uniqSetToList
 delFromNameSet    = delOneFromUniqSet
-foldNameSet	  = foldUniqSet
-filterNameSet	  = filterUniqSet
+foldNameSet       = foldUniqSet
+filterNameSet     = filterUniqSet
 intersectNameSet  = intersectUniqSets
 
 delListFromNameSet set ns = foldl delFromNameSet set ns
@@ -95,22 +89,22 @@ intersectsNameSet s1 s2 = not (isEmptyNameSet (s1 `intersectNameSet` s2))
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Free variables}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 These synonyms are useful when we are thinking of free variables
 
 \begin{code}
-type FreeVars	= NameSet
+type FreeVars   = NameSet
 
 plusFV   :: FreeVars -> FreeVars -> FreeVars
 addOneFV :: FreeVars -> Name -> FreeVars
 unitFV   :: Name -> FreeVars
 emptyFVs :: FreeVars
 plusFVs  :: [FreeVars] -> FreeVars
-mkFVs	 :: [Name] -> FreeVars
+mkFVs    :: [Name] -> FreeVars
 delFV    :: Name -> FreeVars -> FreeVars
 delFVs   :: [Name] -> FreeVars -> FreeVars
 
@@ -119,7 +113,7 @@ isEmptyFVs  = isEmptyNameSet
 emptyFVs    = emptyNameSet
 plusFVs     = unionManyNameSets
 plusFV      = unionNameSets
-mkFVs	    = mkNameSet
+mkFVs       = mkNameSet
 addOneFV    = addOneToNameSet
 unitFV      = unitNameSet
 delFV n s   = delFromNameSet s n
@@ -128,9 +122,9 @@ delFVs ns s = delListFromNameSet s ns
 
 
 %************************************************************************
-%*									*
-		Defs and uses
-%*									*
+%*                                                                      *
+                Defs and uses
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -145,8 +139,8 @@ type Uses = NameSet
 --                      Also, @us@ may mention @ds@.
 --
 -- @Nothing =>@ Nothing is defined in this group, but
--- 	        nevertheless all the uses are essential.
---	        Used for instance declarations, for example
+--              nevertheless all the uses are essential.
+--              Used for instance declarations, for example
 type DefUse  = (Maybe Defs, Uses)
 
 -- | A number of 'DefUse's in dependency order: earlier 'Defs' scope over later 'Uses'
@@ -184,7 +178,7 @@ duUses dus = foldr get emptyNameSet dus
   where
     get (Nothing,   rhs_uses) uses = rhs_uses `unionNameSets` uses
     get (Just defs, rhs_uses) uses = (rhs_uses `unionNameSets` uses)
-				     `minusNameSet` defs
+                                     `minusNameSet` defs
 
 findUses :: DefUses -> Uses -> Uses
 -- ^ Given some 'DefUses' and some 'Uses', find all the uses, transitively.
@@ -194,13 +188,13 @@ findUses dus uses
   = foldr get uses dus
   where
     get (Nothing, rhs_uses) uses
-	= rhs_uses `unionNameSets` uses
+        = rhs_uses `unionNameSets` uses
     get (Just defs, rhs_uses) uses
-	| defs `intersectsNameSet` uses 	-- Used
-	|| any (startsWithUnderscore . nameOccName) (nameSetToList defs)
-		-- At least one starts with an "_", 
-		-- so treat the group as used
-	= rhs_uses `unionNameSets` uses
-	| otherwise	-- No def is used
-	= uses
+        | defs `intersectsNameSet` uses         -- Used
+        || any (startsWithUnderscore . nameOccName) (nameSetToList defs)
+                -- At least one starts with an "_", 
+                -- so treat the group as used
+        = rhs_uses `unionNameSets` uses
+        | otherwise     -- No def is used
+        = uses
 \end{code}
